/**
 * Project: MentDB
 * Description: Mentalese Database Engine
 * Website: http://www.mentdb.org
 * Twitter: https://twitter.com/mentalese_db
 * LinkedIn: https://www.linkedin.com/company/mentdb
 * Facebook: https://www.facebook.com/mentdb
 * Author: Jimmitry Payet
 * Website: http://www.jpayet.re
 * Mail: contact@jpayet.re
 * Locality: Reunion Island (French)
 */

package re.jpayet.mentdb.core.brain;

import org.json.simple.JSONObject;

import re.jpayet.mentdb.MentDBConnector;
import re.jpayet.mentdb.core.entity.stimulation.StimulationManager;
import re.jpayet.mentdb.core.log.Log;
import re.jpayet.mentdb.core.session.Session;
import re.jpayet.mentdb.core.session.SessionThread;
import re.jpayet.mentdb.core.session.env.EnvManager;
import re.jpayet.mentdb.server.Start;

//The brain
public class Brain extends Thread {
	
	public static MentDBConnector aiConnection = null;
	
	//Properties
	public static boolean listening = true;

	//The environment of the AI
	public static EnvManager env = null;

	//The stimulation object
	public static JSONObject stimulation = new JSONObject();
	
	public static long ai_connection_id = 0;
	public static SessionThread session = null;
	public static String user = "ai";

	//Constructor
	public Brain() {

	}

	//Thread run method ...
	public void run () {

		if (aiConnection==null) {
			
			connectAiUser();
		
		}

		//Listening ...
		while (listening) {

			try {
				
				if (StimulationManager.userStimulationStack.size()>0) {

					//Here the external user stimulations

					//Load the first stimulation
					StimulationManager stm = StimulationManager.userStimulationStack.get(0);

					//Delete the stimulation from the stack
					StimulationManager.userStimulationStack.remove(0);
					
					aiConnection.execute("execute \"brain.internal_stimulation\" \"[str]\" \""+stm.sentence.replace("\"", "\\\"")+"\" \"[fromUser]\" \""+stm.fromUser.replace("\"", "\\\"")+"\";");

				} else {
					
					//Wait
					try {

						Thread.sleep(10);

					} catch (Exception e) {};
					
				}

			} catch (Exception e) {

				Log.write("Fatal error: "+e.getMessage());
				re.jpayet.mentdb.core.session.Session.aiSendMessage(0, "Brain error: "+e.getMessage());

			}

		}

	}

	public static void connectAiUser() {

		//Connect to the database
		String password = "aipwd";

		try {

			//Connect to the local mentdb server
			aiConnection = new MentDBConnector("127.0.0.1", Start.SERVER_PORT, Start.SESSION_CONNECT_TIMEOUT, Start.SESSION_TIMEOUT);

			//Connect with 'ai' login
			if (aiConnection.connect(Brain.user, password)) {

				//The ai user was connected
				Session.allConnections.put(Brain.user, aiConnection);

			} else {

				throw new Exception(aiConnection.clientConnectionState);

			}

		} catch (Exception e) {

			if (!(""+e.getMessage()).equals("Disconnected (User already connected ...)")) {
				listening = false;
				Log.write("AI Connection: Fatal error: "+e.getMessage());
				re.jpayet.mentdb.core.session.Session.aiSendMessage(0, "AI Connection: Fatal error: "+e.getMessage());
			}

		}

	}

}