/**
 * Project: MentDB
 * Description: Mentalese Database Engine
 * Website: http://www.mentdb.org
 * Twitter: https://twitter.com/mentalese_db
 * LinkedIn: https://www.linkedin.com/company/mentdb
 * Facebook: https://www.facebook.com/mentdb
 * Author: Jimmitry Payet
 * Website: http://www.jpayet.re
 * Mail: contact@jpayet.re
 * Locality: Reunion Island (French)
 */

package re.jpayet.mentdb.doc;

//Basic doc page
public class Doc_clients {
	
	static String p = "clients";
	
	//Load the page
	public static void load() {
		
		Doc.createPage(p, "Clients");
		
		Doc.createSection(p, "Connect with the Editor", "MentDB_Editor/osx-linux(windows)/bin/editor.sh(bat)<br><br>host: localhost<br>port: 9999<br>user: admin<br>password: pwd<br><br><span style='color:#090;'>Connect with 'admin' user, and type <b>stop {id}</b> to stop the server (Only user in 'system' group).</span><br><br>"+
		"<a href='images/cap01.png' target='_blank'><img src='images/cap01.png' style='width:130px'></a> &nbsp;  &nbsp; "+
		"<a href='images/cap02.png' target='_blank'><img src='images/cap02.png' style='width:130px'></a> &nbsp;  &nbsp; "+
		"<a href='images/cap03.png' target='_blank'><img src='images/cap03.png' style='width:130px'></a> &nbsp;  &nbsp; "+
		"<a href='images/cap04.png' target='_blank'><img src='images/cap04.png' style='width:130px'></a> &nbsp;  &nbsp; "+
		"<a href='images/cap05.png' target='_blank'><img src='images/cap05.png' style='width:130px'></a>");
		
		String ws = "http://localhost:9999/api-rest/?token=&script=&var1=&var2=";
		Doc.createSection(p, "Execute mental script with the REST API (method = POST or GET)", "<div style='font-family:monospace'>"+ws.replace(" ", "&nbsp;")+"</div><br><br><span style='color:#090;'>The user and the mental script must be into the same group, and the user must be in the 'api-rest' group.</span>");
		
		String javaApi = "public static void main(String[] args) {<br>"+
				"<br>"+
				"    //Initialization<br>"+
				"    MentDBConnector connector = null;<br>"+
				"<br>"+
				"    //Try to connect and execute MQL queries<br>"+
				"    try {<br>"+
				"<br>"+
				"      //Server connection (9998 is the database port)<br>"+
				"      connector = new MentDBConnector(\"localhost\", 9998, 10000, 10000);<br>"+
				"<br>"+
				"      //User connection<br>"+
				"      if (connector.connect(\"admin\", \"pwd\")) {<br>"+
				"<br>"+
				"        //Display connection information<br>"+
				"        System.out.println(connector.serverConnectionState);<br>"+
				"        System.out.println(connector.clientConnectionState);<br>"+
				"<br>"+
				"        try {<br>"+
				"          <br>"+
				"          //Execute a MQL query<br>"+
				"          System.out.println(connector.execute(\"who\"));<br>"+
				"<br>"+
				"          //Execute another MQL query<br>"+
				"          System.out.println(connector.execute(\"sessions\"));<br>"+
				"<br>"+
				"        } catch (Exception e) {<br>"+
				"<br>"+
				"          //Exception<br>"+
				"          System.out.println(e.getMessage());<br>"+
				"<br>"+
				"        }<br>"+
				"<br>"+
				"      } else {<br>"+
				"<br>"+
				"        //Display connection information<br>"+
				"        System.out.println(connector.serverConnectionState);<br>"+
				"        System.out.println(connector.clientConnectionState);<br>"+
				"<br>"+
				"      }<br>"+
				"<br>"+
				"    } catch (Exception e) {<br>"+
				"<br>"+
				"      //A connection error was generated<br>"+
				"      System.out.println(e.getMessage());<br>"+
				"<br>"+
				"    } finally {<br>"+
				"<br>"+
				"      try {<br>"+
				"<br>"+
				"        //Close the connector<br>"+
				"        connector.close();<br>"+
				"<br>"+
				"      } catch (Exception e) {<br>"+
				"<br>"+
				"      }<br>"+
				"<br>"+
				"    }<br>"+
				"<br>"+
				"  }<br>";
		Doc.createSection(p, "Java API", "<div style='font-family:monospace'>"+javaApi.replace(" ", "&nbsp;")+"</div>");
		
		String wsApi = "function init() {<br>"+
				"    MentDBWebSocket();<br>"+
				"}<br>"+
				"<br>"+
				"function MentDBWebSocket() {<br>"+
				"    websocket = new WebSocket(\"ws://localhost:9999/mentdb/\");<br>"+
				"    websocket.onopen = function(evt) { onOpen(evt) };<br>"+
				"    websocket.onclose = function(evt) { onClose(evt) };<br>"+
				"    websocket.onmessage = function(evt) { onMessage(evt) };<br>"+
				"    websocket.onerror = function(evt) { onError(evt) };<br>"+
				"}<br>"+
				"<br>"+
				"function onOpen(evt) {<br>"+
				"    websocket.send(\"#login \\\"admin\\\" \\\"pwd\\\"\");<br>"+
				"}<br>"+
				"<br>"+
				"function onClose(evt) {<br>"+
				"  <br>"+
				"}<br>"+
				"<br>"+
				"function onMessage(evt) {<br>"+
				"    //alert(evt.data);<br>"+
				"    var obj = JSON.parse(evt.data);<br>"+
				"}<br>"+
				"<br>"+
				"function onError(evt) {<br>"+
				"  <br>"+
				"}<br>"+
				"<br>"+
				"function disconnect() {<br>"+
				"    websocket.send(\"bye\");<br>"+
				"}<br>"+
				"<br>"+
				"function chatMode() {<br>"+
				"    websocket.send(\"#j8i9m0m5i5t3r2y1p9a6y4e5t%\");<br>"+
				"}<br>"+
				"<br>"+
				"function mqlMode() {<br>"+
				"    websocket.send(\"#j8i9m0m5i5t3r2y1p9a6y4e5t$\");<br>"+
				"}<br>"+
				"<br>"+
				"init();<br>";
		Doc.createSection(p, "Web Socket API", "<div style='font-family:monospace'>"+wsApi.replace(" ", "&nbsp;")+"</div>");
		
	}

}
