/**
 * Project: MentDB
 * Description: Mentalese Database Engine
 * Website: http://www.mentdb.org
 * Twitter: https://twitter.com/mentalese_db
 * LinkedIn: https://www.linkedin.com/company/mentdb
 * Facebook: https://www.facebook.com/mentdb
 * Author: Jimmitry Payet
 * Website: http://www.jpayet.re
 * Mail: contact@jpayet.re
 * Locality: Reunion Island (French)
 */

package re.jpayet.mentdb.doc;

//Basic doc page
public class Doc_config {
	
	static String p = "config";
	
	//Load the page
	public static void load() {
		
		Doc.createPage(p, "Configuration");
		
		Doc.createSection(p, "WARNING", "");

		Doc.createBlockText(p, "<span style='font-weight:bold;color:#F00'>YOU MUST BE AN ADVANCED USER TO CHANGE THE CONFIG FILE.</span>");

		Doc.createSection(p, "Location", "");
		Doc.createBlockText(p, "MentDB_Server/conf/server.conf");
		
		Doc.createSection(p, "Admin", "");

		Doc.createBlockText(p, "PWD: default password 'pwd'");
		
		Doc.createSection(p, "Artificial Intelligence", "");

		Doc.createBlockText(p, "FIRSTNAME: default 'liza'");
		Doc.createBlockText(p, "LASTNAME: default 'payet'");
		
		Doc.createSection(p, "Web Server", "");

		Doc.createBlockText(p, "WEB_SERVER_PORT: default '9999' [integer]");
		
		Doc.createSection(p, "Database engine", "");

		String db = "#Server port [integer]<br>"+
				"SERVER_PORT=9998<br><br>"+
				"#The remote access [ALLOW|DENIED]<br>"+
				"REMOTE_ACCESS=DENIED<br><br>"+
				"#The session connect timeout [long]<br>"+
				"SESSION_CONNECT_TIMEOUT=10000<br><br>"+
				"#The session timeout [long]<br>"+
				"SESSION_TIMEOUT=600000<br><br>"+
				"#Max session open in the same time [integer]<br>"+
				"MAX_SESSION=20<br><br>"+
				"#Number of index file (do not change when data was created) integer]<br>"+
				"NB_INDEX_FILE=1000<br><br>"+
				"#Number of index file open [integer]<br>"+
				"NB_INDEX_FILE_OPEN=1000<br><br>"+
				"#Number of data file open [integer]<br>"+
				"NB_DATA_FILE_OPEN=20<br><br>"+
				"#Data block size (do not change when data was created) + 24 < 65535 [integer]<br>"+
				"DATA_BLOCK_SIZE=1000<br><br>"+
				"#Max data block size [long]<br>"+
				"MAX_DATA_BLOCK_SIZE=10000000<br><br>"+
				"#First language<br>"+
				"FIRST_LANGUAGE=fr<br>"+
				"\n";
		Doc.createBlockText(p, db);
		
		Doc.createSection(p, "Documentation", "");

		Doc.createBlockText(p, "#Do not use<br>check_documentation=1 [1 or 0]");
		
	}

}
